﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

using Visio = Microsoft.Office.Interop.Visio;
using Sakura.GW.Lib;
using Sakura.GW.AbstractLayer;
using Sakura.GW.AbstractLayer.Visio;
using Sakura.GW.Visio.Draw;

namespace VisioAddinGW_App
{
    public partial class Form1 : Form
    {

        //Visioアプリケーションハンドル
        public Visio.Application visioApp = null;
        //GraphWeaver管理マネージャ
        GraphWeaverMng visioManager = null;
        //Visio用描画モジュール
        VisioAddInLib_draw visioDrawModule = null;

        public Form1()
        {
            InitializeComponent();
        }

 
        /// <summary>
        /// Visio終了時コールバック関数
        /// </summary>
        public void CallbackVisioClosedFunc()
        {
            //外部からVisioが終了させられたので、ハンドルをnullに設定
            label1.Text = "Visio終了";
            visioApp = null;
        }

        // Visio Start ボタン
        private void button1_Click(object sender, EventArgs e)
        {
            if (visioApp == null)
            {
                visioApp = (Visio.Application)new Microsoft.Office.Interop.Visio.InvisibleAppClass();
                //描画モジュールにVisioのApplicationハンドルを渡してインスタンス作成
                visioDrawModule = new VisioAddInLib_draw(visioApp);
                //管理マネージャに描画モジュールのハンドルを渡してインスタンス作成
                visioManager = new GraphWeaverMng(visioDrawModule);
                //Visio終了時のコールバック登録
                visioManager.VisioClosedFunc += new GraphWeaverMng.callbackVisioClosed(CallbackVisioClosedFunc);
                //Visioウィンドウ表示
                visioApp.Visible = true;

                label1.Text = "Visio開始";
 
                //管理マネージャ起動
                visioManager.start();
            }
        }

        // End ボタン
        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        // FormClose時の処理
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (visioManager != null)
            {
                //管理マネージャ停止
                visioManager.stop();
            }
            //Visioを閉じる
            if (visioApp != null)
            {
                visioApp.Quit();
            }
            try
            {
                //Visioを閉じる
                if (visioApp != null)
                {
                    visioApp.Quit();
                }
            }
            catch (Exception)
            {

            }
         }

        // Visio End ボタン
        private void button3_Click(object sender, EventArgs e)
        {
            if (visioManager != null)
            {
                //管理マネージャ停止
                visioManager.stop();
            }
            //Visioを閉じる
            if (visioApp != null)
            {
                visioApp.Quit();
            }
            try
            {
                //Visioを閉じる
                if (visioApp != null)
                {
                    visioApp.Quit();
                    //visioApp = null;
                }
            }
            catch (Exception)
            {

            }
        }
    }
}
